import os
import sys
sys.path.append("/net/fantasia/home/alextsoi/code/Network")
sys.path.append(os.getcwd())
from ggscoreGraph import *
from kou import *

def FunMST(funSP,funintgenes):
	"""given a graph funSP (contain all pairwise shortest distances and shortest paths), and funintgenes, output the minimum spanning trees (forest)
	for those genes in funintgenes but not in funSP, they are seemed as one isolated tree !!!	
	"""	
	if len(funintgenes)==0:
		return Graph()

	returngraph=Graph()
	### get the subgraph from funSP for the funintgenes
	funintSP=Graph(funSP.subgraph(funintgenes))	
	###print "funintSP # of genes:" + str(len(funintSP.nodes()))
	###print "funintSP # of components:" + str(len(connected_components(funintSP)))
	### get the funintgenes that are not in the funintSP
	returngraph.add_nodes_from(list(set(funintgenes)-set(funintSP.nodes())))
	###print "returngraph # of genes after add_nodes_from: " +str(len(returngraph.nodes()))
	###print "returngraph # of components after add_nodes_from: " +str(len(connected_components(returngraph)))
	### for each connected component in funintSP, get the MST by calling the Kou algorithm
	for i in connected_components(funintSP):
		if len(i)==1:
			returngraph.add_node(i[0])
			continue
		tempsubgraph=Graph(funintSP.subgraph(i))
		tempreturngraph=Graph(kou_givenclique(tempsubgraph, tempsubgraph.nodes()))
		returngraph=union_all([returngraph,tempreturngraph])
	return returngraph

